%global debug_package %{nil}

Name:           oraclelinux-release-el10
Version:        1.0
Release:        12%{dist}
Summary:        Oracle Linux DNF repository configuration

Group:          System Environment
License:        GPLv2

Source0:        LICENSE
Source1:        oracle-linux-ol10.repo
Source2:        oracle-linux-ol10.repo.aarch64
Source3:        uek-ol10.repo
Source4:        uek-ol10.repo.aarch64

BuildArch:     x86_64 aarch64
Requires:      grep
Requires:      sed
Requires:      curl


%description
This package contains the  Oracle Linux DNF repository configuration.

%prep
%setup  -q  -c -T

%build

%install
rm -rf $RPM_BUILD_ROOT


install -m 755 -d $RPM_BUILD_ROOT/usr/share/doc/%{name}/
install -dm 755 $RPM_BUILD_ROOT%{_sysconfdir}/yum.repos.d
install -m 755 %{SOURCE0}  $RPM_BUILD_ROOT%{_datadir}/doc/%{name}
install -pm 644 %{SOURCE3} $RPM_BUILD_ROOT%{_sysconfdir}/yum.repos.d/
%if "%{?_host_cpu}" == "x86_64"
install -pm 644 %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/yum.repos.d/
%endif
%if "%{?_host_cpu}" == "aarch64"
install -pm 644 %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/yum.repos.d/oracle-linux-ol10.repo
install -pm 644 %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}/yum.repos.d/uek-ol10.repo
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%dir %{_datadir}/doc/%{name}
%{_datadir}/doc/%{name}/*
%config(noreplace) /etc/yum.repos.d/*


%post

instance_command='curl --max-time 1 -q -f http://169.254.169.254/opc/v2/instance/'
if [ -d /etc/yum/vars ]; then
  yumvars_dir=/etc/yum/vars
else
  if [ ! -d /etc/dnf/vars ]; then
    mkdir -p /etc/dnf/vars
    chmod 755 /etc/dnf/vars
  fi
  yumvars_dir=/etc/dnf/vars
fi

if [ ! -f $yumvars_dir/ociregion ]; then
(http_proxy="";curl --max-time 1 -q -f http://169.254.169.254/opc/v2/instance/ -H "Authorization: Bearer Oracle" > /dev/null 2>&1)
 if [ $? != 0 ]; then
   echo > $yumvars_dir/ociregion
   echo oracle.com > $yumvars_dir/ocidomain
 else
  instance_region=$(http_proxy="";$instance_command -H "Authorization: Bearer Oracle" -s 2> /dev/null | grep regionIdentifier | awk -F\: '{print $2}' | sed -e 's/\"//g' -e 's/ //g' -e 's/,//g')
  instance_domain=$(http_proxy="";$instance_command -H "Authorization: Bearer Oracle" -s 2> /dev/null | grep realmDomainComponent | awk -F: '{print $2}' | sed -e 's/"//g' -e 's/,//g' -e 's/^\s//g')
  instance_realm=$(http_proxy="";$instance_command -H "Authorization: Bearer Oracle" -s 2>/dev/null | grep realmKey | awk -F: '{print $2}' | sed -e 's/"//g' -e 's/,//g' -e 's/^\s//g')
  if [ -z "$instance_region" -o -z "$instance_domain" ]; then
    echo > $yumvars_dir/ociregion
    echo oracle.com > $yumvars_dir/ocidomain
  else
    if curl -sfm 25 http://yum-${instance_region}.oracle.com &> /dev/null || curl -sfm 25 https://yum.${instance_region}.oci.${instance_domain} &> /dev/null; then
        echo oci.$instance_domain > $yumvars_dir/ocidomain
        echo ".$instance_region" > $yumvars_dir/ociregion
    else
        echo > $yumvars_dir/ociregion
        echo oracle.com > $yumvars_dir/ocidomain
     fi
  fi
 fi
fi

if [ ! -f $yumvars_dir/ocidomain ]; then
   (http_proxy="";$instance_command -H "Authorization: Bearer Oracle" > /dev/null 2>&1)
    if [ $? != 0 ]; then
      echo oracle.com > $yumvars_dir/ocidomain
    else
     instance_domain=$(http_proxy="";$instance_command -H "Authorization: Bearer Oracle" -s 2> /dev/null | grep realmDomainComponent | awk -F: '{print $2}' | sed -e 's/"//g' -e 's/,//g' -e 's/^\s//g')
     instance_realm=$(http_proxy="";$instance_command -H "Authorization: Bearer Oracle" -s 2>/dev/null | grep realmKey | awk -F: '{print $2}' | sed -e 's/"//g' -e 's/,//g' -e 's/^\s//g')
       if [ -z $instance_domain ]; then
         echo oracle.com > $yumvars_dir/ocidomain
       elif [[ -n $instance_realm ]]; then
          echo oci.$instance_domain > $yumvars_dir/ocidomain
       else
          echo oracle.com > $yumvars_dir/ocidomain
       fi
    fi
fi


%changelog
* Tue Jun 17 2025 Alex Burmashev <alexander.burmashev@oracle.com> - 1.0-12
- Add RDMA repositories [Orabug: 38082087]

* Sat May 24 2025 Alex Burmashev <alexander.burmashev@oracle.com> - 1.0-11
- Update repository channel names [Orabug: 37990234]

* Fri May 23 2025 Alex Burmashev <alexander.burmashev@oracle.com> - 1.0-10
- Switch to OL10 GA repositories [Orabug: 37988350]

* Thu Apr 17 2025 Alex Burmashev <alexander.burmashev@oracle.com> - 1.0-9
- Fix gpgkey link for UEKR8 developer repository [Orabug: 37798550]

* Tue Feb 04 2025 Alex Burmashev <alexander.burmashev@oracle.com> - 1.0-8
- Add UEK8 developer repository

* Tue Jan 15 2025 Alex Burmashev <alexander.burmashev@oracle.com> - 1.0-7
- Increase priority for UEK-next repository [Orabug: 37481141]

* Tue Jan 14 2025 Alex Burmashev <alexander.burmashev@oracle.com> - 1.0-6
- Update UEK-next repository naming [Orabug: 37475240]

* Mon Jan 13 2025 Alex Burmashev <alexander.burmashev@oracle.com> - 1.0-5
- Use generic URLs for repositories

* Mon Dec 16 2024 Alex Burmashev <alexander.burmashev@oracle.com> - 1.0-4
- Add UEK-next developer repositories

* Fri Dec 06 2024 Alex Burmashev <alexander.burmashev@oracle.com> - 1.0-3
- Fix aarch64 repository naming 

* Thu Dec 05 2024 Alex Burmashev <alexander.burmashev@oracle.com> - 1.0-2
- Use developer URLs for repositories

* Tue Nov 26 2024 Alex Burmashev <alexander.burmashev@oracle.com> - 1.0-1
- Initial release for Oracle Linux 10
